package org.jamon.node;

import java.util.ArrayList;
import java.util.List;

import org.jamon.api.Location;
public class AbstractBodyNode extends AbstractNode
{
  public AbstractBodyNode(Location p_location)
  {
    super(p_location);
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseAbstractBodyNode(this);
  }

  private final List<AbstractNode> m_subNodes = new ArrayList<AbstractNode>();
  public AbstractBodyNode addSubNode(AbstractNode p_subNode)
  {
    if (p_subNode == null) { throw new NullPointerException(); }
    m_subNodes.add(p_subNode);
    return this;
  }
  public List<AbstractNode> getSubNodes() { return m_subNodes; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_subNodes.equals(((AbstractBodyNode) p_obj).m_subNodes)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_subNodes.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addPropertyList(p_buffer, "subNode", m_subNodes);
  }

}
