package org.jamon.node;

import java.util.ArrayList;
import java.util.List;

import org.jamon.api.Location;
public class AbstractPathNode extends AbstractNode
{
  public AbstractPathNode(Location p_location)
  {
    super(p_location);
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseAbstractPathNode(this);
  }

  private final List<AbstractPathElementNode> m_pathElements = new ArrayList<AbstractPathElementNode>();
  public AbstractPathNode addPathElement(AbstractPathElementNode p_pathElement)
  {
    if (p_pathElement == null) { throw new NullPointerException(); }
    m_pathElements.add(p_pathElement);
    return this;
  }
  public List<AbstractPathElementNode> getPathElements() { return m_pathElements; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_pathElements.equals(((AbstractPathNode) p_obj).m_pathElements)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_pathElements.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addPropertyList(p_buffer, "pathElement", m_pathElements);
  }

}
