package org.jamon.node;

import org.jamon.api.Location;
public class EmitNode extends AbstractNode
{
  public EmitNode(Location p_location, String p_emitExpression, AbstractEscapeNode p_escaping)
  {
    super(p_location);
    if ((m_emitExpression = p_emitExpression) == null)
      { throw new NullPointerException(); }
    if ((m_escaping = p_escaping) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseEmitNode(this);
  }

  private final String m_emitExpression;
  public String getEmitExpression() { return m_emitExpression; }

  private final AbstractEscapeNode m_escaping;
  public AbstractEscapeNode getEscaping() { return m_escaping; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_emitExpression.equals(((EmitNode) p_obj).m_emitExpression)
      && m_escaping.equals(((EmitNode) p_obj).m_escaping)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_emitExpression.hashCode()
      ^ m_escaping.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "emitExpression", m_emitExpression);
    addProperty(p_buffer, "escaping", m_escaping);
  }

}
