package org.jamon.node;

import java.util.ArrayList;
import java.util.List;

import org.jamon.api.Location;
public class ImplementsNode extends AbstractNode
{
  public ImplementsNode(Location p_location)
  {
    super(p_location);
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseImplementsNode(this);
  }

  private final List<ImplementNode> m_implements = new ArrayList<ImplementNode>();
  public ImplementsNode addImplement(ImplementNode p_implement)
  {
    if (p_implement == null) { throw new NullPointerException(); }
    m_implements.add(p_implement);
    return this;
  }
  public List<ImplementNode> getImplements() { return m_implements; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_implements.equals(((ImplementsNode) p_obj).m_implements)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_implements.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addPropertyList(p_buffer, "implement", m_implements);
  }

}
