package org.jamon.node;

import java.util.ArrayList;
import java.util.List;

import org.jamon.api.Location;
public class MultiFragmentCallNode extends AbstractComponentCallNode
{
  public MultiFragmentCallNode(Location p_location, AbstractPathNode p_callPath, AbstractParamsNode p_params)
  {
    super(p_location, p_callPath, p_params);
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseMultiFragmentCallNode(this);
  }

  private final List<NamedFragmentNode> m_fragments = new ArrayList<NamedFragmentNode>();
  public MultiFragmentCallNode addFragment(NamedFragmentNode p_fragment)
  {
    if (p_fragment == null) { throw new NullPointerException(); }
    m_fragments.add(p_fragment);
    return this;
  }
  public List<NamedFragmentNode> getFragments() { return m_fragments; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_fragments.equals(((MultiFragmentCallNode) p_obj).m_fragments)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_fragments.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addPropertyList(p_buffer, "fragment", m_fragments);
  }

}
