package org.jamon.node;

import org.jamon.api.Location;
public class WhileNode extends AbstractBodyNode
{
  public WhileNode(Location p_location, String p_condition)
  {
    super(p_location);
    if ((m_condition = p_condition) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseWhileNode(this);
  }

  private final String m_condition;
  public String getCondition() { return m_condition; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_condition.equals(((WhileNode) p_obj).m_condition)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_condition.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "condition", m_condition);
  }

}
